commit a5c3168ddbe3d98a5abdd928de5b6a02ef521a2d
Author: Oto Šťáva <ostava@students.zcu.cz>
Date:   Wed Jun 2 09:09:58 2021 +0000

    Re #9000 - On-site adjustments

diff --git a/deltarobot-vr/Assets/DeltaRobotVr/Client.cs b/deltarobot-vr/Assets/DeltaRobotVr/Client.cs
index ac331b3..0c791cf 100644
--- a/deltarobot-vr/Assets/DeltaRobotVr/Client.cs
+++ b/deltarobot-vr/Assets/DeltaRobotVr/Client.cs
@@ -46,7 +46,7 @@ namespace DeltaRobotVr
 
         private const int ReconnectPollMillis = 200;
         private const int ReconnectTimeMillis = 3000;
-
+        private const int ConnectTimeoutMillis = 3000;
         
         private Thread _thread;
         
@@ -287,7 +287,16 @@ namespace DeltaRobotVr
                         port = DefaultPort;
                     }
 
-                    using var client = new TcpClient(host, port);
+                    using var client = new TcpClient();
+                    var asyncConnect = client.BeginConnect(host, port, null, null);
+
+                    var connected = asyncConnect.AsyncWaitHandle.WaitOne(TimeSpan.FromMilliseconds(ConnectTimeoutMillis));
+                    if (!connected)
+                    {
+                        Debug.LogWarning("Connection not established - timed out");
+                        continue;
+                    }
+                    
                     using var stream = client.GetStream();
                     BinaryReader reader = new BinaryReader(stream);
                     BinaryWriter writer = new BinaryWriter(stream);
diff --git a/deltarobot-vr/Assets/DeltaRobotVr/Components/Curve.cs b/deltarobot-vr/Assets/DeltaRobotVr/Components/Curve.cs
index 2930664..ec712e6 100644
--- a/deltarobot-vr/Assets/DeltaRobotVr/Components/Curve.cs
+++ b/deltarobot-vr/Assets/DeltaRobotVr/Components/Curve.cs
@@ -6,18 +6,22 @@ namespace DeltaRobotVr.Components
     {
         private long _currentCounter;
         private LineRenderer _lineRenderer;
-        
+
         void Start()
         {
             _currentCounter = Client.Instance.CurveCounter;
             _lineRenderer = GetComponent<LineRenderer>();
 
             // Set curve color
-            var color = UnityEngine.Color.yellow;
+            var color = Color.yellow;
             var cs = ConfigurationProvider.Instance.CurveColorHex;
             ColorUtility.TryParseHtmlString(cs, out color);
-
+            
             _lineRenderer.material.color = color;
+
+            var widthCurve = new AnimationCurve();
+            widthCurve.AddKey(0.0f, ConfigurationProvider.Instance.VisualizationScaleOverall * 1);
+            _lineRenderer.widthCurve = widthCurve;
         }
 
         void Update()
diff --git a/deltarobot-vr/Assets/Materials/ActuatorMaterial.mat b/deltarobot-vr/Assets/Materials/ActuatorMaterial.mat
index cb1df02..dbe0f32 100644
--- a/deltarobot-vr/Assets/Materials/ActuatorMaterial.mat
+++ b/deltarobot-vr/Assets/Materials/ActuatorMaterial.mat
@@ -9,12 +9,13 @@ Material:
   m_PrefabAsset: {fileID: 0}
   m_Name: ActuatorMaterial
   m_Shader: {fileID: 46, guid: 0000000000000000f000000000000000, type: 0}
-  m_ShaderKeywords: 
+  m_ShaderKeywords: _ALPHAPREMULTIPLY_ON
   m_LightmapFlags: 4
   m_EnableInstancingVariants: 0
   m_DoubleSidedGI: 0
-  m_CustomRenderQueue: -1
-  stringTagMap: {}
+  m_CustomRenderQueue: 3000
+  stringTagMap:
+    RenderType: Transparent
   disabledShaderPasses: []
   m_SavedProperties:
     serializedVersion: 3
@@ -59,20 +60,20 @@ Material:
     - _BumpScale: 1
     - _Cutoff: 0.5
     - _DetailNormalMapScale: 1
-    - _DstBlend: 0
+    - _DstBlend: 10
     - _GlossMapScale: 1
     - _Glossiness: 0.5
     - _GlossyReflections: 1
     - _Metallic: 0
-    - _Mode: 0
+    - _Mode: 3
     - _OcclusionStrength: 1
     - _Parallax: 0.02
     - _SmoothnessTextureChannel: 0
     - _SpecularHighlights: 1
     - _SrcBlend: 1
     - _UVSec: 0
-    - _ZWrite: 1
+    - _ZWrite: 0
     m_Colors:
-    - _Color: {r: 0, g: 0.61987686, b: 1, a: 1}
+    - _Color: {r: 0, g: 0.6198768, b: 1, a: 0.8352941}
     - _EmissionColor: {r: 0, g: 0, b: 0, a: 1}
   m_BuildTextureStacks: []
diff --git a/deltarobot-vr/Assets/Materials/CurveMaterial.mat b/deltarobot-vr/Assets/Materials/CurveMaterial.mat
index a374faa..e9f562d 100644
--- a/deltarobot-vr/Assets/Materials/CurveMaterial.mat
+++ b/deltarobot-vr/Assets/Materials/CurveMaterial.mat
@@ -9,12 +9,13 @@ Material:
   m_PrefabAsset: {fileID: 0}
   m_Name: CurveMaterial
   m_Shader: {fileID: 46, guid: 0000000000000000f000000000000000, type: 0}
-  m_ShaderKeywords: 
+  m_ShaderKeywords: _ALPHAPREMULTIPLY_ON
   m_LightmapFlags: 4
   m_EnableInstancingVariants: 0
   m_DoubleSidedGI: 0
-  m_CustomRenderQueue: -1
-  stringTagMap: {}
+  m_CustomRenderQueue: 3000
+  stringTagMap:
+    RenderType: Transparent
   disabledShaderPasses: []
   m_SavedProperties:
     serializedVersion: 3
@@ -59,20 +60,20 @@ Material:
     - _BumpScale: 1
     - _Cutoff: 0.5
     - _DetailNormalMapScale: 1
-    - _DstBlend: 0
+    - _DstBlend: 10
     - _GlossMapScale: 1
     - _Glossiness: 0.5
     - _GlossyReflections: 1
     - _Metallic: 0
-    - _Mode: 0
+    - _Mode: 3
     - _OcclusionStrength: 1
     - _Parallax: 0.02
     - _SmoothnessTextureChannel: 0
     - _SpecularHighlights: 1
     - _SrcBlend: 1
     - _UVSec: 0
-    - _ZWrite: 1
+    - _ZWrite: 0
     m_Colors:
-    - _Color: {r: 1, g: 1, b: 0, a: 1}
+    - _Color: {r: 1, g: 1, b: 0, a: 0.7019608}
     - _EmissionColor: {r: 0, g: 0, b: 0, a: 1}
   m_BuildTextureStacks: []
diff --git a/deltarobot-vr/Assets/Scenes/MainScene.unity b/deltarobot-vr/Assets/Scenes/MainScene.unity
index 247bf72..a86d456 100644
--- a/deltarobot-vr/Assets/Scenes/MainScene.unity
+++ b/deltarobot-vr/Assets/Scenes/MainScene.unity
@@ -38,7 +38,7 @@ RenderSettings:
   m_ReflectionIntensity: 1
   m_CustomReflection: {fileID: 0}
   m_Sun: {fileID: 0}
-  m_IndirectSpecularColor: {r: 0.13630313, g: 0.13304767, b: 0.13535894, a: 1}
+  m_IndirectSpecularColor: {r: 0.13630301, g: 0.13304764, b: 0.1353588, a: 1}
   m_UseRadianceAmbientProbe: 0
 --- !u!157 &3
 LightmapSettings:
diff --git a/deltarobot-vr/Assets/XR/Settings/Open XR Package Settings.asset b/deltarobot-vr/Assets/XR/Settings/Open XR Package Settings.asset
index 5b41e0e..8cb9cf9 100644
--- a/deltarobot-vr/Assets/XR/Settings/Open XR Package Settings.asset	
+++ b/deltarobot-vr/Assets/XR/Settings/Open XR Package Settings.asset	
@@ -53,17 +53,17 @@ MonoBehaviour:
   m_Name: Standalone
   m_EditorClassIdentifier: 
   features:
+  - {fileID: 2403943066524059476}
   - {fileID: 2043135668846800584}
+  - {fileID: -1904082576570179865}
   - {fileID: -6096981118822911806}
   - {fileID: -271836654803105724}
   - {fileID: -3694410627744314491}
   - {fileID: -7447083962620800966}
   - {fileID: -1776479383642935546}
-  - {fileID: 2403943066524059476}
-  - {fileID: -794994281501537552}
   - {fileID: -335466943738423260}
-  - {fileID: -1904082576570179865}
   - {fileID: 6355736994434073062}
+  - {fileID: -794994281501537552}
   m_renderMode: 1
   m_depthSubmissionMode: 0
 --- !u!114 &-3694410627744314491
diff --git a/deltarobot-vr/ProjectSettings/EditorBuildSettings.asset b/deltarobot-vr/ProjectSettings/EditorBuildSettings.asset
index c3a8ade..552c47d 100644
--- a/deltarobot-vr/ProjectSettings/EditorBuildSettings.asset
+++ b/deltarobot-vr/ProjectSettings/EditorBuildSettings.asset
@@ -5,12 +5,12 @@ EditorBuildSettings:
   m_ObjectHideFlags: 0
   serializedVersion: 2
   m_Scenes:
-  - enabled: 1
-    path: Assets/Scenes/BasicRoomScene.unity
-    guid: c3ae6736b8d472d43a729f249f998f5c
   - enabled: 1
     path: Assets/Scenes/MainScene.unity
     guid: 9fc0d4010bbf28b4594072e72b8655ab
+  - enabled: 1
+    path: Assets/Scenes/BasicRoomScene.unity
+    guid: c3ae6736b8d472d43a729f249f998f5c
   - enabled: 1
     path: Assets/UsedAssets/_Barking_Dog/3D Free Modular Kit/NeonRoom.unity
     guid: 7b533dfe561bc47c8975c955fe4ef3d3
diff --git a/deltarobot-vr/ProjectSettings/ProjectSettings.asset b/deltarobot-vr/ProjectSettings/ProjectSettings.asset
index a0e39fe..e56e634 100644
--- a/deltarobot-vr/ProjectSettings/ProjectSettings.asset
+++ b/deltarobot-vr/ProjectSettings/ProjectSettings.asset
@@ -128,7 +128,8 @@ PlayerSettings:
     16:9: 1
     Others: 1
   bundleVersion: 0.1
-  preloadedAssets: []
+  preloadedAssets:
+  - {fileID: -5491969387593978816, guid: 4f95031940154b14299cd50ae865e7e6, type: 2}
   metroInputSource: 0
   wsaTransparentSwapchain: 0
   m_HolographicPauseOnTrackingLoss: 1
@@ -689,7 +690,7 @@ PlayerSettings:
   platformArchitecture: {}
   scriptingBackend:
     Android: 1
-    Standalone: 1
+    Standalone: 0
   il2cppCompilerConfiguration: {}
   managedStrippingLevel: {}
   incrementalIl2cppBuild: {}
diff --git a/deltarobot-vr/ProjectSettings/UnityConnectSettings.asset b/deltarobot-vr/ProjectSettings/UnityConnectSettings.asset
index fa0b146..6125b30 100644
--- a/deltarobot-vr/ProjectSettings/UnityConnectSettings.asset
+++ b/deltarobot-vr/ProjectSettings/UnityConnectSettings.asset
@@ -9,6 +9,7 @@ UnityConnectSettings:
   m_EventOldUrl: https://api.uca.cloud.unity3d.com/v1/events
   m_EventUrl: https://cdp.cloud.unity3d.com/v1/events
   m_ConfigUrl: https://config.uca.cloud.unity3d.com
+  m_DashboardUrl: https://dashboard.unity3d.com
   m_TestInitMode: 0
   CrashReportingSettings:
     m_EventUrl: https://perf-events.cloud.unity3d.com